<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EcoPerformanceProfileParameter StructType
 * @subpackage Structs
 */
class EcoPerformanceProfileParameter extends AbstractStructBase
{
    /**
     * The Target
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Target;
    /**
     * The Sensitivity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Sensitivity;
    /**
     * The Weight
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Weight;
    /**
     * Constructor method for EcoPerformanceProfileParameter
     * @uses EcoPerformanceProfileParameter::setTarget()
     * @uses EcoPerformanceProfileParameter::setSensitivity()
     * @uses EcoPerformanceProfileParameter::setWeight()
     * @param float $target
     * @param float $sensitivity
     * @param float $weight
     */
    public function __construct($target = null, $sensitivity = null, $weight = null)
    {
        $this
            ->setTarget($target)
            ->setSensitivity($sensitivity)
            ->setWeight($weight);
    }
    /**
     * Get Target value
     * @return float
     */
    public function getTarget()
    {
        return $this->Target;
    }
    /**
     * Set Target value
     * @param float $target
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public function setTarget($target = null)
    {
        // validation for constraint: float
        if (!is_null($target) && !(is_float($target) || is_numeric($target))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($target, true), gettype($target)), __LINE__);
        }
        $this->Target = $target;
        return $this;
    }
    /**
     * Get Sensitivity value
     * @return float
     */
    public function getSensitivity()
    {
        return $this->Sensitivity;
    }
    /**
     * Set Sensitivity value
     * @param float $sensitivity
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public function setSensitivity($sensitivity = null)
    {
        // validation for constraint: float
        if (!is_null($sensitivity) && !(is_float($sensitivity) || is_numeric($sensitivity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sensitivity, true), gettype($sensitivity)), __LINE__);
        }
        $this->Sensitivity = $sensitivity;
        return $this;
    }
    /**
     * Get Weight value
     * @return float
     */
    public function getWeight()
    {
        return $this->Weight;
    }
    /**
     * Set Weight value
     * @param float $weight
     * @return \StructType\EcoPerformanceProfileParameter
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: float
        if (!is_null($weight) && !(is_float($weight) || is_numeric($weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        $this->Weight = $weight;
        return $this;
    }
}
